/*
   FILNAME:			

   PURPOSE:			

   CREATED BY:		Per Ghosh (email: hulken@algonet.se)
   ENVIRONEMENT:	Visual C++


INFO:


LOG:
Sign.. Date... Comment........................................................................
	   
*/

#include "stdafx.h"
#include "Modal.h"
#include "frameModal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



IMPLEMENT_DYNAMIC(CCframeModal, CFrameWnd)

static TCHAR* module_pszText =
   _T("HOW TO CREATE YOUR OWN MODAL WINDOW IN MFC.\n")
   _T("\n")
   _T("Look in the functions\n")
   _T("CModalDoc::OnModalShowmodalframe()\n")
   _T("CCframeModal::OnClose()\n")
   _T("\n")
   _T("HOW TO DO IT !\n")
   _T("Create a window (not a dialog) that should be modal.\n")
   _T("Before you are going to show the window that should be modal, disable\n")
   _T("the application window. Then you call the function RunModalLoop()\n")
   _T("\n")
   _T("CATCHES\n")
   _T("Don't destroy the window before ending the modal loop. You have to control\n")
   _T("the destroying of the window your self. A good way is to delete the window\n")
   _T("where you created it (Se: CModalDoc::OnModalShowmodalframe(). If you don't\n")
   _T("do this the program can go down.\n")
   _T("\n")
   _T("// Per Ghosh (email: hulken@algonet.se)");


/************************************************
   *   Constructor/Destructor 
   *
 * * *
  ***
   *
*/

//-------------------------------------------------------------------------------------------------
CCframeModal::CCframeModal()
{
   m_pFont = NULL;
}

//-------------------------------------------------------------------------------------------------
CCframeModal::~CCframeModal()
{
   if( m_pFont ) delete m_pFont;
}


BEGIN_MESSAGE_MAP(CCframeModal, CFrameWnd)
	//{{AFX_MSG_MAP(CCframeModal)
	ON_WM_PAINT()
	ON_WM_CLOSE()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/************************************************
   *   Virtual 
   *
 * * *
  ***
   *
*/


/* ------------------------------------------------------------------------------------------------
 * NAME:    PreCreateWindow()
 * PURPOSE: Called by the framework before the creation of the Windows window attached to this CWnd 
 *          object
 * 
 * PARAM:   cs = CREATESTRUCT structure that defines the initialization parameters passed to the 
 *               window procedure of an application
 */
BOOL CCframeModal::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.lpszClass = AfxRegisterWndClass( CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS,
		   	                           LoadCursor(NULL, IDC_ARROW), 
		   	                           (HBRUSH)(COLOR_WINDOWTEXT+1));
	
	return CFrameWnd::PreCreateWindow(cs);
}


/* ------------------------------------------------------------------------------------------------
 * NAME:    OnPaint()
 * PURPOSE: Paint information in window here
 */
void CCframeModal::OnPaint() 
{
   CFont*   pfontOld;
   CRect    rect;
	CPaintDC dc(this);
   
   GetClientRect( &rect );                                  // get the workingarea of window
   rect.InflateRect( -5, -5 );                              // decrease it the area

   dc.SetTextColor( ::GetSysColor( COLOR_WINDOW ) );        // chose font color
   dc.SetBkMode( TRANSPARENT );
   
   pfontOld = dc.SelectObject( m_pFont );                   // chose a font

   // Draw information text
   ::DrawTextEx( dc.m_hDC, m_pszText, m_uTextLength, &rect, DT_WORDBREAK, NULL );

   dc.SelectObject( pfontOld );                             // restore the font
}

/************************************************
   *   Functions 
   *
 * * *
  ***
   *
*/

/* ------------------------------------------------------------------------------------------------
 * NAME:    InitialUpdate()
 * PURPOSE: Update members
 */
void CCframeModal::InitialUpdate()
{
	LOGFONT logfont;
   memset( &logfont, 0, sizeof( LOGFONT ) );
   logfont.lfHeight = 18;
   strcpy(logfont.lfFaceName,"MS Sans Serif"); 
	m_pFont = new CFont();
	m_pFont->CreateFontIndirect(&logfont); 

   m_pszText     = module_pszText;
   m_uTextLength = _tcslen( module_pszText );

}

/************************************************
   *   Messages
   *
 * * *
  ***
   *
*/

/* ------------------------------------------------------------------------------------------------
 * NAME:    OnCreate()
 * PURPOSE: framework calls this member function when an application requests that the Windows 
 *          window be created
 */
int CCframeModal::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	InitialUpdate();
	
	return 0;
}



/* ------------------------------------------------------------------------------------------------
 * NAME:    OnClose()
 * PURPOSE: When the window gets closed we hide it. The window has to be destroyed some where else
 *          in the code. Tip: Destroy the window where yoy created it.
 */
void CCframeModal::OnClose() 
{
   // end the modal loop
   EndModalLoop( TRUE );                                    

   // enable the main application window or else another application can be activated
   ::EnableWindow( AfxGetApp()->m_pMainWnd->m_hWnd, TRUE ); 
	
   // hide this window (don't destroy it)
	ShowWindow( SW_HIDE ); 
}





